function v = netcdf_forward_advection_NSF_Alpha(t, app)

t0 = app.t0;
tEnd = app.tEnd;
t0_sim = app.t0_sim;
dt_sim = app.dt_sim;
ncid = app.ncid;

t_upper = ceil((tEnd + t0 - t - t0_sim)/dt_sim);
t_lower = t_upper - 1;

alpha = ((tEnd + t0 - t - t0_sim)/dt_sim - t_lower);

u_vel = ncid{'vtot'}(t_lower + 1 : t_upper + 1, 1:end-1, 1:end-1, 1, 1);
v_vel = ncid{'vtot'}(t_lower + 1 : t_upper + 1, 1:end-1, 1:end-1, 1, 2);

u_vel(abs(u_vel) >= 1000) = 0;
v_vel(abs(v_vel) >= 1000) = 0;

u_vel = u_vel/100;
v_vel = v_vel/100;

U = (1 - alpha)*squeeze(u_vel(1, :, :, :)) ...
      + (alpha)*squeeze(u_vel(2, :, :, :));
  
V = (1 - alpha)*squeeze(v_vel(1, :, :, :)) ...
      + (alpha)*squeeze(v_vel(2, :, :, :));

v{1} = U';
v{2} = V';

% v{1} = U;
% v{2} = V;
% v{3} = -W;

end
